module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var currentCompInst = null;
var callIndex = 0;

/**
 * 分离 data 和 methods
 */
function splitDef(def) {
  var data = {};
  var methods = {};
  Object.keys(def).forEach(function (key) {
    var value = def[key];
    if (typeof value === 'function' && value._isUpdater) {
      methods[key] = value.bind(null);
    } else {
      data[key] = value;
    }
  });

  return { data: data, methods: methods };
}

function useState(initValue) {
  if (!currentCompInst) throw new Error('component instance not found!');

  var index = callIndex++;
  var compInst = currentCompInst;

  if (compInst._$state[index] === undefined) compInst._$state[index] = initValue;

  var updater = function updater(evt) {
    var value = evt;

    // wxml 事件回调
    if ((typeof evt === 'undefined' ? 'undefined' : _typeof(evt)) === 'object' && evt.target && evt.currentTarget) {
      var dataset = evt.currentTarget.dataset;
      value = dataset && dataset.arg;
    }

    // 存入缓存
    compInst._$state[index] = value;
    compInst._$func();
  };
  updater._isUpdater = true;

  return [compInst._$state[index], updater];
}

function useEffect(effectFunc, deps) {
  if (!currentCompInst) throw new Error('component instance not found!');

  var index = callIndex++;
  var compInst = currentCompInst;
  var effect = compInst._$effect[index];

  if (effect === undefined) {
    // 初次渲染
    compInst._$effect[index] = {
      unload: effectFunc.call(null),
      lastDeps: deps
    };
  } else if (!effect.lastDeps && !deps) {
    // 后续渲染，没有带依赖列表
    effect.unload = effectFunc.call(null);
  } else {
    // 后续渲染，带依赖列表
    for (var i = 0, len = deps.length; i < len; i++) {
      if (effect.lastDeps[i] !== deps[i]) {
        effect.unload = effectFunc.call(null);
        effect.lastDeps = deps;
        break;
      }
    }
  }
}

function FunctionalComponent(func) {
  func = typeof func === 'function' ? func : function () {};

  // 定义自定义组件
  return Component({
    attached: function attached() {
      var _this = this;

      this._$state = {};
      this._$effect = {};
      this._$func = function () {
        currentCompInst = _this;
        callIndex = 0;
        var newDef = func.call(null) || {};
        currentCompInst = null;

        var _splitDef = splitDef(newDef),
            data = _splitDef.data,
            methods = _splitDef.methods;

        // 设置 methods


        Object.keys(methods).forEach(function (key) {
          _this[key] = methods[key];
        });

        // 设置 data
        _this.setData(data);
      };

      this._$func();
    },
    detached: function detached() {
      var _this2 = this;

      Object.keys(this._$effect).forEach(function (key) {
        var effect = _this2._$effect[key];
        var unload = effect.unload;

        if (typeof unload === 'function') unload.call(null);
      });

      this._$state = null;
      this._$effect = null;
      this._$func = null;
    }
  });
}

module.exports = {
  useState: useState,
  useEffect: useEffect,
  FunctionalComponent: FunctionalComponent
};

/***/ })
/******/ ]);